// CFTTVector32x4 - [2020-04-13 11:57:46]
#ifndef _CFTTVECTOR32X4_H_
#define _CFTTVECTOR32X4_H_

#include "CFTTVector32.h"

/*
0014BFF8 CFTTVector32x4::operator-(CFTTVector32x4 const&)
*/

class CFTTVector32x4 {
public:
  CFTTVector32x4(){};
  CFTTVector32x4(float f1, float f2, float f3, float f4) {
    my[0] = f1;
    my[1] = f2;
    my[2] = f3;
    my[3] = f4;
  }

  CFTTVector32x4(CFTTVector32 ftt, float f) {
    my[0] = ftt.float_0;
    my[1] = ftt.float_4;
    my[2] = ftt.float_8;
    my[3] = f;
  };

  CFTTVector32x4 &operator=(CFTTVector32 &other) {
    my[3] = 0.0f;
    memcpy(my, &other, sizeof(CFTTVector32));
    return *this;
  };

  static CFTTVector32x4 Format(CFTTVector32 ftt, float f) {
    return CFTTVector32x4(ftt, f);
  };

  // 0014BFF8 //^_^
  CFTTVector32x4 operator-(const CFTTVector32x4 &other) const;

  float my[4];
  // float32x4_t my;
  static CFTTVector32x4 s_vZeroVector;  // 005CDEC0
};

#endif  //_CFTTVECTOR32X4_H_